#!/usr/local/bin/perl
#
# File Upload Script        Version 3.2
# Created by Jeff Carnahan  jeffc@terminalp.com
# Created on: 4/8/95        Last Modified on: 05/12/96 17:27 
# Scripts Archive:          http://www.terminalp.com/scripts/
#
# Copyright (C) 1996 - Jeffrey D. Carnahan
#   Copyright Information Can Be found in the attacted README file.
#
# ---------------------------------------------------------------------
# Program Specific Quickie Notes:
#     * Make Sure The First Line Is Pointing To The Correct Location Of Perl.
#     * Make Sure This Program is chmodded with the permissions '755'.
#     * Make Sure You Have The correct information in @refer.

# ---------------------------------------------------------------------
# Configurable Options Follow:
#

        $userid = "5000";
        $groupid = "1000";
        $url = "http://www.csnet.net/register/upload/";
        $path = "/export/home/www/register/upload/";
        $overwrite = 0;
        $index_rename = 1;  #yes
        $rename_val = "index0.html"; #rename it to this
        @refer = ('www.csnet.net','csnet.net','199.0.0.19');


#
# End of Configurable Options.
# ---------------------------------------------------------------------
# ---------------------------------------------------------------------
# Don't Modify Anything Past This Line Unless You Know What Your Doing!
# ---------------------------------------------------------------------
# ---------------------------------------------------------------------
#

&CheckHost;

$| = 1;  # Set This To 1, so Perl doesn't Buffer the Data... =)

if ($ENV{'REQUEST_METHOD'} eq "POST") {
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
} elsif ($ENV{'REQUEST_METHOD'} eq "GET") {
        $buffer=$ENV{'QUERY_STRING'};
  }

$buffer =~ /^(.+)\r\n/;
$bound = $1;
@pairs = split(/$bound/, $buffer);
print "Content-type: text/html\n\n";

if (@pairs != 4) {
    print "<HTML><HEAD><TITLE>Sorry!</TITLE></HEAD><BODY BGCOLOR=\"#FFFFFF\">";
    print "<H1>Sorry.</H1>";
    print "<p>Sorry, your browser doesn't support the HTML 3.0 codes needed to upload files.";
    print " Please try again with a browser that supports these functions, (Such as <a href=\"";
    print "http://home.netscape.com/comprod/products/navigator/version_2.0/index.html\">Netscape 2.0</a>.)\n";
    print "</BODY></HTML>\n";
    exit;
}


$agent = $ENV{'HTTP_USER_AGENT'};
@var = split(/\r\n/,$pairs[1]);
$filename = $var[3];
if ($filename !~ /[A-Za-z_\-0-9.]/) {
        print "<HTML><HEAD><TITLE>Sorry!</TITLE></HEAD><BODY BGCOLOR=\"\#FFFFFF\">";
        print "<H1>Sorry.</H1>";
        print "<p>Sorry, the file you want to upload contains illegal characters.  Please only use characters that include any combinations of letters, underscores (<i>_</i>), hyphens, numbers, or periods.";
        print "<br>Please select another filename and try again.\n";
        print "</BODY></HTML>\n";
        exit;
}
if ($index_rename) {
    $filename =~ s/index.html/$rename_val/g;
}
$pairs[2] =~ s/^\r\n.+filename.+[^\w\.\%-]([\w\.\%-]+)"\r\n(.*\r\n)\r\n//;
$pairs[2] =~ s/\r\n$//;

if ($overwrite) {
    open (OUTPUT, "> $path/$filename" ) || die &NoOpen($!);
    print OUTPUT $pairs[2];
    close (OUTPUT);
    chmod (0644, "$path/$filename");
    chown ($userid, $groupid, $file);
} else {
    if (-e "$path/$filename") {
        print "<HTML><HEAD><TITLE>Sorry!</TITLE></HEAD><BODY BGCOLOR=\"#FFFFFF\">";
        print "<H1>Sorry.</H1>";
        print "<p>Sorry, the file you want to write to is already in use, and you are not allowed to overwrite it.";
        print " Please select another filename and try again.\n";
        print "</BODY></HTML>\n";
        exit;
    } else {
        open (OUTPUT, "> $path/$filename" ) || die &NoOpen($!);
        print OUTPUT $pairs[2];
        close (OUTPUT);
        chmod (0644, "$path/$filename");
        chown ($userid, $groupid, $file);
    }
}



print "<HTML><HEAD><TITLE>Thanks!</TITLE></HEAD><BODY BGCOLOR=\"#FFFFFF\">";
print "<h1>Thanks!</h1>\n";
print "<p>Thanks for uploading the file: $filename.  It is now known under the URL of: <a href=\"";
print "$url/$filename\">$url/$filename</a>. If you would like to upload another file, click <a href=\"";
print "$ENV{'HTTP_REFERER'}\">here</a> to return to the previous page.\n";
print "<p><hr size=1>\n";
print "<font size=-1><center><a href=\"http://www.terminalp.com/scripts/\">Obtain This Script</a> - <a href=\"mailto:jeffc\@terminalp.com\">jeffc\@terminalp.com</a></center></font>\n";
print "</BODY></HTML>\n";


sub NoOpen {
    print "<HTML><HEAD><TITLE>Error!!</TITLE></HEAD><BODY BGCOLOR=\"#FFFFFF\">\n";
    print "<H1>Error!</H1>\n";
    print "<p>There was an error: <b><pre>@_[0]</pre></b>\n";
    print "<br>Please make sure that the directory the file should be written to, <i>$upload_dir</i>, has been chmodded with the premissions <i>777</i>.\n";
    print "<br>Or, if you are trying to overwrite a existing file, check to see that the existing file has been chmodded with the premissions <i>666</i>.\n";
    print "<p><hr size=1>\n";
    print "<font size=-1><center><a href=\"http://www.terminalp.com/scripts/\">Obtain This Script</a> - <a href=\"mailto:jeffc\@terminalp.com\">jeffc\@terminalp.com</a></center></font>\n";
    print "</BODY></HTML>\n";
}


sub CheckHost {
    if ($ENV{'HTTP_REFERER'}) {
        foreach (@refer) {
            if ($ENV{'HTTP_REFERER'} =~ /$_/i) {
                $ok = 1;
    	        last;
        }   }
    } else { # If There isn't a refering URL, then we'll assume it's ok.
        $ok = 1;
    }
    if ($ok) { # It Checked, We Can Continue
    } else {   # Nope... Someone's trying to hack their way in.
        print "Content-type: text/html\n\n";
        print "<HTML><HEAD><TITLE>Sorry!</TITLE></HEAD><BODY BGCOLOR=\"#FFFFFF\">";
        print "<H1>Sorry.</H1>\n";
        print "<p>Sorry, you are not allowed to post information to this server from <a href=\"";
        print "$ENV{'HTTP_REFERER'}\">$ENV{'HTTP_REFERER'}</a>.  Please Use a document that is already";
        print " on this server to upload a file.\n";
        print "</BODY></HTML>\n";
        exit;
    }   
}
